#ifndef I18N_H
#define I18N_H
/* Internationalization declarations */

enum msg_group_t {
	ANNOUNCE_ID, FORMAT_ID, COLOR_ID,
	CONTROL_ID, STATE_ID, FUNC_ID,
	KEY_ID, MAX_ID
};

#define FORMAT_START FORMAT_ID*256
#define KEY_START KEY_ID*256
#define BRIGHT 9
#define BLINKING 10

enum msg_index_t {
	MSG_BLANK, MSG_IAM_ALIVE,
	MSG_YOU_KILLED_SPEAKUP, MSG_HEY_THATS_BETTER,
	MSG_YOU_TURNED_ME_OFF,
	MSG_PARKED, MSG_UNPARKED,
	MSG_MARK, MSG_MARK_CLEARED,
	MSG_WINDOW_ALREADY_SET, MSG_NO_WINDOW,
	MSG_EDIT_DONE,
	MSG_COLUMNS, MSG_INDENT,
	MSG_END_BEFORE_START,
	MSG_WINDOW_CLEARED, MSG_WINDOW_SILENCED,
	MSG_WINDOW_SILENCE_DISABLED, MSG_WINDOW_LONG_HEADER,
	MSG_ERROR, MSG_NO_BUFF,
	MSG_FIND, MSG_NOT_FOUND,
	MSG_HELP_INFO, MSG_DONE_HELP,
	MSG_VARS_INFO, MSG_DONE_VARS,
	MSG_IS_UNASSIGNED,
	MSG_GOTO, MSG_ROUTE_FAILED,
	MSG_EDGE_TOP, MSG_EDGE_BOTTOM,
	MSG_EDGE_LEFT, MSG_EDGE_RIGHT,
	MSG_MULTI, MSG_SINGLE,
	MSG_NUMBER, MSG_SPACE,
	MSG_START, MSG_END, // for window start/end
	MSG_HEADER_START, MSG_HEADER_END, // for header start/end
	MSG_CTRL, MSG_OFF, MSG_ON,
	MSG_DISJUNCTION, // the word "or"
	MSG_POS_INFO = FORMAT_START,
	MSG_CHAR_INFO,
	MSG_REPEAT_DESC,
	MSG_REPEAT_DESC2,
	MSG_WINDOW_LINE,
	MSG_WINDOW_BOUNDARY,
	MSG_EDIT_PROMPT,
	MSG_NO_COMMAND,
	MSG_KEYDESC,
	MSG_CANCELED,
};

struct st_msg_group {
	char *name;
	char **defaults;
	char **messages;
	enum msg_group_t group_id;
	int size;
};

typedef  struct st_msg_group tmsg_group, *pmsg_group;

char *spk_msg_get(enum msg_index_t msg);
char *spk_msg_get2(enum msg_group_t group_id, int msg);
void spk_msg_say(enum msg_index_t msg);
void spk_msg_say2(enum msg_group_t group_id, int msg);
void spk_msg_say_sp(enum msg_index_t msg);
ssize_t spk_msg_set(pmsg_group group, int msg, char *text, size_t length);
pmsg_group spk_find_msg_group(const char *group_name);
pmsg_group spk_get_msg_group(enum msg_group_t group_id);
void spk_reset_msg_group(pmsg_group group);
void spk_initialize_msgs(void);
void spk_free_user_msgs(void);

#endif
